Subject: 27.0.50; CC-Mode problems with function definitions with macro names
From: Mauro Aranda <[email-masked]>
To: bug-gnu-emacs <[email-masked]>
Date: Thu, 16 May 2019 19:19:09 -0300
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello.

I noticed CC-Mode sometimes doesn't identify correctly function names
when a macro name is involved in the function definition.  Try the
following recipe to see the problem:

1) emacs -Q
2) C-x C-f test.c
3) Type the following function definitions:

int DUMMY
foo (void)
{
  return 1;
}

DUMMY int
bar (void)
{
  return 0;
}

4) Observe that:
a) foo doesn't get fontified with font-lock-function-name-face, but
DUMMY does.  Consequently, C-c C-z inside foo echoes
DUMMY as the function name, in the echo area.
b) In bar, DUMMY gets font-lock-type-face, which I don't
think is correct.  bar gets font-lock-function-name-face and C-c C-z
works as expected.

---

Other problem is with fontification of the return type in the following:

bool DUMMY
baz_t (void)
{
  return true;
}

bool
baz_f (void)
{
  return false;
}

Observe that bool doesn't get fontified in baz_t, but DUMMY does.  When
DUMMY is not present, bool gets fontified correctly (as in baz_f).

If it helps, I found the problem in a source file with functions that
have macros that declare some function attributes, like
_GL_ATTRIBUTE_PURE.

Best regards,
Mauro.

In GNU Emacs 27.0.50 (build 5, i686-pc-linux-gnu, GTK+ Version 3.18.9)
 of 2019-05-15 built on the-blackbeard
Repository revision: 50b1ce0185cd7b5f8be124eb4a612fd56e4e0657
Repository branch: revert-buffer-with-fine-grain
Windowing system distributor 'The X.Org Foundation', version 11.0.11906000
System Description: Ubuntu 16.04.6 LTS

Recent messages:
For information about GNU Emacs and the GNU system, type C-h C-a.

Configured using:
 'configure CFLAGS=-O3'

Configured features:
XPM JPEG TIFF GIF PNG RSVG SOUND GPM DBUS GSETTINGS GLIB NOTIFY INOTIFY
ACL LIBSELINUX GNUTLS LIBXML2 FREETYPE M17N_FLT LIBOTF XFT ZLIB
TOOLKIT_SCROLL_BARS GTK3 X11 XDBE XIM THREADS PDUMPER LCMS2 GMP

Important settings:
  value of $LANG: en_US.utf8
  value of $XMODIFIERS:
  locale-coding-system: utf-8-unix

Major mode: Lisp Interaction

Minor modes in effect:
  tooltip-mode: t
  global-eldoc-mode: t
  eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message rmc puny seq byte-opt gv
bytecomp byte-compile cconv dired dired-loaddefs format-spec rfc822 mml
easymenu mml-sec password-cache epa derived epg epg-config gnus-util
rmail rmail-loaddefs text-property-search time-date mm-decode mm-bodies
mm-encode mail-parse rfc2231 mailabbrev gmm-utils mailheader cl-loaddefs
cl-lib sendmail rfc2047 rfc2045 ietf-drums mm-util mail-prsvr mail-utils
elec-pair mule-util tooltip eldoc electric uniquify ediff-hook vc-hooks
lisp-float-type mwheel term/x-win x-win term/common-win x-dnd tool-bar
dnd fontset image regexp-opt fringe tabulated-list replace newcomment
text-mode elisp-mode lisp-mode prog-mode register page menu-bar
rfn-eshadow isearch timer select scroll-bar mouse jit-lock font-lock
syntax facemenu font-core term/tty-colors frame cl-generic cham georgian
utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao korean
japanese eucjp-ms cp51932 hebrew greek romanian slovak czech european
ethiopic indian cyrillic chinese composite charscript charprop
case-table epa-hook jka-cmpr-hook help simple abbrev obarray minibuffer
cl-preloaded nadvice loaddefs button faces cus-face macroexp files
text-properties overlay sha1 md5 base64 format env code-pages mule
custom widget hashtable-print-readable backquote threads dbusbind
inotify lcms2 dynamic-setting system-font-setting font-render-setting
move-toolbar gtk x-toolkit x multi-tty make-network-process emacs)

Memory information:
((conses 8 43995 8711)
 (symbols 24 5878 1)
 (strings 16 14997 2517)
 (string-bytes 1 501374)
 (vectors 8 8875)
 (vector-slots 4 114380 10618)
 (floats 8 18 13)
 (intervals 28 194 0)
 (buffers 564 11)
 (heap 1024 7599 790))